#include "Arduino.h"
#include <SoftwareSerial.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <Adafruit_Sensor.h>
#include <DHT.h>
#define DHTPIN 2 //DHT 22 pin
#define DHTTYPE DHT11 // definition of type of sensor
#define relay 4 //relay pin
LiquidCrystal_I2C lcd(0x27, 16, 2); //LCD size
DHT dht = DHT(DHTPIN, DHTTYPE);
const byte rxPin = 9;
const byte txPin = 8;
SoftwareSerial BTSerial(rxPin, txPin); // RX TX
 
void setup() {
// define pin modes for tx, rx:
  pinMode(rxPin, INPUT);
  pinMode(txPin, OUTPUT);
  pinMode(relay, OUTPUT);
  //initializing of modules
  Serial.begin(9600);
  BTSerial.begin(9600);
  lcd.init();
  lcd.backlight(); 
  dht.begin();
}

void loop() {
delay(2000);
float h = dht.readHumidity(); //definition of temperature
float t = dht.readTemperature(); //definition of temperature
int y1 = analogRead(A0); //definition of input from potentiometer
int angle = map(y1, 0, 1023, 0, 255); //convertion of input from potentiometer to temperature values out of angle
float ST = angle/10;
bool r_stat = false;

if (isnan(h) || isnan(t)) //to check if the DHT sensor is working
    {
    lcd.setCursor(0,0);
    lcd.print("Failed to read");
    lcd.setCursor(0,1);
    lcd.print("from DHT sensor!");
    lcd.clear();
    return;
    }
  lcd.setCursor(0,0); //displays the Temeprature
  lcd.print("T:");
  lcd.print(t);

  lcd.setCursor(8,0); //sets the target Temperature
  lcd.print("ST:");
  lcd.print(ST);

  lcd.setCursor(0,1); //shows the Humidity
  lcd.print("H:");
  lcd.print(h);
  lcd.print("%"); 

  BTSerial.print(t);
  BTSerial.print(";");
  BTSerial.print(h);
  BTSerial.print(";");
  BTSerial.print(ST);
  
  
    if(t > ST){
     digitalWrite(relay, HIGH);
     r_stat = true;
    }
    else{
      delay(5000);
      digitalWrite(relay, LOW);
      r_stat = false;
    }
  BTSerial.print(";");
  BTSerial.print(r_stat);

  }

